diff -r -u squid-2.6.STABLE13/src/neighbors.c new-STABLE13/src/neighbors.c
--- squid-2.6.STABLE13/src/neighbors.c	Tue Feb 27 07:45:24 2007
+++ new-STABLE13/src/neighbors.c	Sun May 13 00:59:37 2007
@@ -53,7 +53,7 @@
 static void peerCountMcastPeersStart(void *data);
 static void peerCountMcastPeersSchedule(peer * p, time_t when);
 static IRCB peerCountHandleIcpReply;
-static void neighborIgnoreNonPeer(const struct sockaddr_in *, icp_opcode);
+static void neighborIgnoreNonPeer(const struct sockaddr *, icp_opcode);
 static OBJH neighborDumpPeers;
 static OBJH neighborDumpNonPeers;
 static void dump_peers(StoreEntry * sentry, peer * peers);
@@ -78,17 +78,30 @@
 
 
 peer *
-whichPeer(const struct sockaddr_in * from)
+whichPeer(const struct sockaddr * from)
 {
     int j;
-    u_short port = ntohs(from->sin_port);
-    struct in_addr ip = from->sin_addr;
+    u_short port; 
     peer *p = NULL;
-    debug(15, 3) ("whichPeer: from %s port %d\n", inet_ntoa(ip), port);
+    char hbuf[80], sbuf[8];
+    getnameinfo(from, SOCKLEN(from), hbuf, 80, sbuf, 8,
+	NI_NUMERICHOST|NI_NUMERICSERV);
+    debug(15, 3) ("whichPeer: from %s port %s\n", hbuf, sbuf);
     for (p = Config.peers; p; p = p->next) {
 	for (j = 0; j < p->n_addresses; j++) {
-	    if (ip.s_addr == p->addresses[j].s_addr && port == p->icp.port) {
-		return p;
+	    if (from->sa_family !=  p->addresses[j].ss_family)
+		continue;
+	    switch (from->sa_family) {
+		case AF_INET6:
+		if ( IN6_ARE_ADDR_EQUAL(&((struct sockaddr_in6 *)&p->addresses[j])->sin6_addr, &((struct sockaddr_in6 *)from)->sin6_addr) &&
+		    (p->icp.port == ntohs(((struct sockaddr_in6 *)from)->sin6_port)))
+		    return p;
+		break;
+		case AF_INET:
+		if ( (((struct sockaddr_in *)&p->addresses[j])->sin_addr.s_addr == ((struct sockaddr_in *)from)->sin_addr.s_addr) &&
+		    (p->icp.port == ntohs(((struct sockaddr_in *)from)->sin_port)))
+		    return p;
+		break;
 	    }
 	}
     }
@@ -145,9 +158,9 @@
     if (p->access == NULL)
 	return do_ping;
     memset(&checklist, '\0', sizeof(checklist));
-    checklist.src_addr = request->client_addr;
-    checklist.my_addr = request->my_addr;
-    checklist.my_port = request->my_port;
+    xmemcpy(&checklist.src_addr, &request->client_addr, sizeof(struct sockaddr_storage));
+    xmemcpy(&checklist.my_addr, &request->my_addr, sizeof(struct sockaddr_storage));
+    xmemcpy(&checklist.my_port, &request->my_port, sizeof(struct sockaddr_storage));
     checklist.request = request;
 #if 0 && USE_IDENT
     /*
@@ -367,15 +380,15 @@
 void
 neighbors_init(void)
 {
-    struct sockaddr_in name;
-    socklen_t len = sizeof(struct sockaddr_in);
+    struct sockaddr_storage name;
+    socklen_t len = sizeof(struct sockaddr_storage);
     struct servent *sep = NULL;
     const char *me = getMyHostname();
     peer *this;
     peer *next;
     int fd = theInIcpConnection;
     if (fd >= 0) {
-	memset(&name, '\0', sizeof(struct sockaddr_in));
+	memset(&name, '\0', sizeof(struct sockaddr_storage));
 	if (getsockname(fd, (struct sockaddr *) &name, &len) < 0)
 	    debug(15, 1) ("getsockname(%d,%p,%p) failed.\n", fd, &name, &len);
 	for (this = Config.peers; this; this = next) {
@@ -384,7 +397,9 @@
 	    if (0 != strcmp(this->host, me))
 		continue;
 	    for (s = Config.Sockaddr.http; s; s = s->next) {
-		if (this->http_port != ntohs(s->s.sin_port))
+		if (this->http_port != ((s->s.ss_family == AF_INET6) ? 
+			ntohs(((struct sockaddr_in6 *)&s->s)->sin6_port) :
+			ntohs(((struct sockaddr_in *)&s->s)->sin_port)) )
 		    continue;
 		debug(15, 1) ("WARNING: Peer looks like this host\n");
 		debug(15, 1) ("         Ignoring %s %s/%d/%d\n",
@@ -402,7 +417,7 @@
 	echo_hdr.reqnum = 0;
 	echo_hdr.flags = 0;
 	echo_hdr.pad = 0;
-	echo_hdr.shostid = name.sin_addr.s_addr;
+	xmemcpy(&echo_hdr.shostid, &name, len);
 	sep = getservbyname("echo", "udp");
 	echo_port = sep ? ntohs((u_short) sep->s_port) : 7;
     }
@@ -457,7 +472,11 @@
 	debug(15, 4) ("neighborsUdpPing: pinging peer %s for '%s'\n",
 	    p->host, url);
 	if (p->type == PEER_MULTICAST)
-	    mcastSetTtl(theOutIcpConnection, p->mcast.ttl);
+	    if (p->in_addr.ss_family == AF_INET6)
+		mcastSetTtl(theOutIcpConnection6, p->mcast.ttl);
+	    else
+	    if (p->in_addr.ss_family == AF_INET)
+		mcastSetTtl(theOutIcpConnection, p->mcast.ttl);
 	debug(15, 3) ("neighborsUdpPing: key = '%s'\n", storeKeyText(entry->hash.key));
 	debug(15, 3) ("neighborsUdpPing: reqnum = %d\n", reqnum);
 
@@ -471,22 +490,36 @@
 	    debug(15, 4) ("neighborsUdpPing: Looks like a dumb cache, send DECHO ping\n");
 	    echo_hdr.reqnum = reqnum;
 	    query = icpCreateMessage(ICP_DECHO, 0, url, reqnum, 0);
-	    icpUdpSend(theOutIcpConnection,
-		&p->in_addr,
-		query,
-		LOG_ICP_QUERY,
-		0);
+	    if (p->in_addr.ss_family == AF_INET6)
+		icpUdpSend(theOutIcpConnection6,
+		    &p->in_addr,
+		    query,
+		    LOG_ICP_QUERY,
+		    0);
+	    else
+		icpUdpSend(theOutIcpConnection,
+		    &p->in_addr,
+		    query,
+		    LOG_ICP_QUERY,
+		    0);
 	} else {
 	    flags = 0;
 	    if (Config.onoff.query_icmp)
 		if (p->icp.version == ICP_VERSION_2)
 		    flags |= ICP_FLAG_SRC_RTT;
 	    query = icpCreateMessage(ICP_QUERY, flags, url, reqnum, 0);
-	    icpUdpSend(theOutIcpConnection,
-		&p->in_addr,
-		query,
-		LOG_ICP_QUERY,
-		0);
+	    if (p->in_addr.ss_family == AF_INET6)
+		icpUdpSend(theOutIcpConnection6,
+		    &p->in_addr,
+		    query,
+		    LOG_ICP_QUERY,
+		    0);
+	    else
+		icpUdpSend(theOutIcpConnection,
+		    &p->in_addr,
+		    query,
+		    LOG_ICP_QUERY,
+		    0);
 	}
 	queries_sent++;
 
@@ -742,23 +775,31 @@
 static peer *non_peers = NULL;
 
 static void
-neighborIgnoreNonPeer(const struct sockaddr_in *from, icp_opcode opcode)
+neighborIgnoreNonPeer(const struct sockaddr *from, icp_opcode opcode)
 {
     peer *np;
     for (np = non_peers; np; np = np->next) {
-	if (np->in_addr.sin_addr.s_addr != from->sin_addr.s_addr)
+	if (from->sa_family !=  np->in_addr.ss_family)
 	    continue;
-	if (np->in_addr.sin_port != from->sin_port)
+	if ((from->sa_family == AF_INET6) &&
+	    IN6_ARE_ADDR_EQUAL(&((struct sockaddr_in6 *)&np->in_addr)->sin6_addr, &((struct sockaddr_in6 *)from)->sin6_addr) &&
+	    (((struct sockaddr_in6 *)&np->in_addr)->sin6_port == ntohs(((struct sockaddr_in6 *)from)->sin6_port)))
+	    continue;
+	else
+	if ((from->sa_family == AF_INET) &&
+	    (((struct sockaddr_in *)&np->in_addr)->sin_addr.s_addr == ((struct sockaddr_in *)from)->sin_addr.s_addr) &&
+	    (((struct sockaddr_in *)&np->in_addr)->sin_port == ntohs(((struct sockaddr_in *)from)->sin_port)))
 	    continue;
 	break;
     }
     if (np == NULL) {
 	np = xcalloc(1, sizeof(peer));
-	np->in_addr.sin_addr = from->sin_addr;
-	np->in_addr.sin_port = from->sin_port;
-	np->icp.port = ntohl(from->sin_port);
+	xmemcpy(&np->in_addr, &from, sizeof(struct sockaddr_storage));
+	np->icp.port = ntohs( (from->sa_family == AF_INET6) ?
+		((struct sockaddr_in6 *)from)->sin6_port :
+		((struct sockaddr_in *)from)->sin_port );
 	np->type = PEER_NONE;
-	np->host = xstrdup(inet_ntoa(from->sin_addr));
+	np->host = xstrdup(sockaddr_ntoa(from));
 	np->next = non_peers;
 	non_peers = np;
     }
@@ -793,7 +834,7 @@
  * If a hit process is already started, then sobeit
  */
 void
-neighborsUdpAck(const cache_key * key, icp_common_t * header, const struct sockaddr_in *from)
+neighborsUdpAck(const cache_key * key, icp_common_t * header, const struct sockaddr *from)
 {
     peer *p = NULL;
     StoreEntry *entry;
@@ -883,7 +924,7 @@
 	    mem->ping_reply_callback(NULL, ntype, PROTO_ICP, header, mem->ircb_data);
 #endif
 	} else {
-	    debug(15, 1) ("Unsolicited SECHO from %s\n", inet_ntoa(from->sin_addr));
+	    debug(15, 1) ("Unsolicited SECHO from %s\n", sockaddr_ntoa(from));
 	}
     } else if (opcode == ICP_DENIED) {
 	if (p == NULL) {
@@ -997,7 +1038,7 @@
 peerDNSConfigure(const ipcache_addrs * ia, void *data)
 {
     peer *p = data;
-    struct sockaddr_in *ap;
+    struct sockaddr_storage *ap;
     int j;
     if (p->n_addresses == 0) {
 	debug(15, 1) ("Configuring %s %s/%d/%d\n", neighborTypeStr(p),
@@ -1016,15 +1057,17 @@
     }
     p->tcp_up = PEER_TCP_MAGIC_COUNT;
     for (j = 0; j < (int) ia->count && j < PEER_MAX_ADDRESSES; j++) {
-	p->addresses[j] = ia->in_addrs[j];
-	debug(15, 2) ("--> IP address #%d: %s\n", j, inet_ntoa(p->addresses[j]));
+	xmemcpy(&p->addresses[j], &ia->in_addrs[j], sizeof(struct sockaddr_storage));
+	debug(15, 2) ("--> IP address #%d: %s\n", j, sockaddr_ntoa(&p->addresses[j]));
 	p->n_addresses++;
     }
-    ap = &p->in_addr;
-    memset(ap, '\0', sizeof(struct sockaddr_in));
-    ap->sin_family = AF_INET;
-    ap->sin_addr = p->addresses[0];
-    ap->sin_port = htons(p->icp.port);
+    ap = (struct sockaddr_storage *)&p->in_addr;
+    memset(ap, '\0', sizeof(struct sockaddr_storage));
+    xmemcpy(ap, &p->addresses[0], sizeof(struct sockaddr_storage));
+    if (ap->ss_family == AF_INET6)
+	((struct sockaddr_in6 *)ap)->sin6_port = htons(p->icp.port);
+    else
+	((struct sockaddr_in *)ap)->sin_port = htons(p->icp.port);
     if (p->type == PEER_MULTICAST)
 	peerCountMcastPeersSchedule(p, 10);
     if (p->type != PEER_MULTICAST)
@@ -1104,6 +1147,7 @@
 peerProbeConnect(peer * p)
 {
     int fd;
+    struct sockaddr_storage outsock;
     time_t ctimeout = p->connect_timeout > 0 ? p->connect_timeout
     : Config.Timeout.peer_connect;
     int ret = squid_curtime - p->stats.last_connect_failure > ctimeout * 10;
@@ -1111,16 +1155,18 @@
 	return ret;		/* probe already running */
     if (squid_curtime - p->stats.last_connect_probe == 0)
 	return ret;		/* don't probe to often */
-    fd = comm_open(SOCK_STREAM, IPPROTO_TCP, getOutgoingAddr(NULL),
-	0, COMM_NONBLOCKING, p->host);
+    memset(&outsock, '\0', sizeof(outsock));
+    outsock.ss_family = p->in_addr.ss_family;
+    fd = comm_open(SOCK_STREAM, IPPROTO_TCP, &outsock,
+	COMM_NONBLOCKING, p->host);
     if (fd < 0)
 	return ret;
     commSetTimeout(fd, ctimeout, peerProbeConnectTimeout, p);
     p->test_fd = fd;
     p->stats.last_connect_probe = squid_curtime;
+    p->ia_cur = -1;
     commConnectStart(p->test_fd,
-	p->host,
-	p->http_port,
+	p->host, p->http_port,
 	peerProbeConnectDone,
 	p);
     return ret;
@@ -1161,10 +1207,14 @@
     MemObject *mem;
     icp_common_t *query;
     int reqnum;
+    int is_ipv6 = 0;
     LOCAL_ARRAY(char, url, MAX_URL);
     assert(p->type == PEER_MULTICAST);
     p->mcast.flags.count_event_pending = 0;
-    snprintf(url, MAX_URL, "http://%s/", inet_ntoa(p->in_addr.sin_addr));
+    if (p->in_addr.ss_family == AF_INET6)
+	is_ipv6 = 1;
+    snprintf(url, MAX_URL, "http://%s%s%s/", is_ipv6 ? "[" : "", 
+	sockaddr_ntoa(&p->in_addr), is_ipv6 ? "]" : "");
     fake = storeCreateEntry(url, url, null_request_flags, METHOD_GET);
     psstate = cbdataAlloc(ps_state);
     psstate->request = requestLink(urlParse(METHOD_GET, url));
@@ -1178,15 +1228,25 @@
     mem->start_ping = current_time;
     mem->ping_reply_callback = peerCountHandleIcpReply;
     mem->ircb_data = psstate;
-    mcastSetTtl(theOutIcpConnection, p->mcast.ttl);
+    if (p->in_addr.ss_family == AF_INET6)
+	mcastSetTtl(theOutIcpConnection6, p->mcast.ttl);
+    else
+	mcastSetTtl(theOutIcpConnection, p->mcast.ttl);
     p->mcast.id = mem->id;
     reqnum = icpSetCacheKey(fake->hash.key);
     query = icpCreateMessage(ICP_QUERY, 0, url, reqnum, 0);
-    icpUdpSend(theOutIcpConnection,
-	&p->in_addr,
-	query,
-	LOG_ICP_QUERY,
-	0);
+    if (p->in_addr.ss_family == AF_INET6)
+	icpUdpSend(theOutIcpConnection6,
+	    &p->in_addr,
+	    query,
+	    LOG_ICP_QUERY,
+	    0);
+    else
+	icpUdpSend(theOutIcpConnection,
+	    &p->in_addr,
+	    query,
+	    LOG_ICP_QUERY,
+	    0);
     fake->ping_status = PING_WAITING;
     eventAdd("peerCountMcastPeersDone",
 	peerCountMcastPeersDone,
@@ -1336,7 +1396,7 @@
 	dump_peer_options(sentry, e);
 	for (i = 0; i < e->n_addresses; i++) {
 	    storeAppendPrintf(sentry, "Address[%d] : %s\n", i,
-		inet_ntoa(e->addresses[i]));
+		sockaddr_ntoa(&e->addresses[i]));
 	}
 	storeAppendPrintf(sentry, "Status     : %s\n",
 	    neighborUp(e) ? "Up" : "Down");
@@ -1404,7 +1464,7 @@
 
 #if USE_HTCP
 void
-neighborsHtcpReply(const cache_key * key, htcpReplyData * htcp, const struct sockaddr_in *from)
+neighborsHtcpReply(const cache_key * key, htcpReplyData * htcp, const struct sockaddr *from)
 {
     StoreEntry *e = storeGet(key);
     MemObject *mem = NULL;
diff -r -u squid-2.6.STABLE13/src/net_db.c new-STABLE13/src/net_db.c
--- squid-2.6.STABLE13/src/net_db.c	Tue Jun  6 07:47:01 2006
+++ new-STABLE13/src/net_db.c	Sun May 13 00:59:37 2007
@@ -697,7 +697,7 @@
 }
 
 void
-netdbHandlePingReply(const struct sockaddr_in *from, int hops, int rtt)
+netdbHandlePingReply(const struct sockaddr *from, int hops, int rtt)
 {
 #if USE_ICMP
     netdbEntry *n;
@@ -735,7 +735,7 @@
 }
 
 int
-netdbHops(struct in_addr addr)
+netdbHops(struct sockaddr *addr)
 {
 #if USE_ICMP
     netdbEntry *n = netdbLookupAddr(addr);
@@ -905,7 +905,7 @@
 }
 
 void
-netdbDeleteAddrNetwork(struct in_addr addr)
+netdbDeleteAddrNetwork(struct sockaddr *addr)
 {
 #if USE_ICMP
     netdbEntry *n = netdbLookupAddr(addr);
diff -r -u squid-2.6.STABLE13/src/pconn.c new-STABLE13/src/pconn.c
--- squid-2.6.STABLE13/src/pconn.c	Tue May 23 06:54:56 2006
+++ new-STABLE13/src/pconn.c	Sun May 13 00:59:37 2007
@@ -49,7 +49,7 @@
 
 static PF pconnRead;
 static PF pconnTimeout;
-static int pconnKey(char *buf, const char *host, u_short port, const char *domain, struct in_addr *client_address, u_short client_port);
+static int pconnKey(char *buf, const char *host, u_short port, const char *domain, struct sockaddr *client_address);
 static hash_table *table = NULL;
 static struct _pconn *pconnNew(const char *key);
 static void pconnDelete(struct _pconn *p);
@@ -62,16 +62,16 @@
 
 static int
 pconnKey(char *buf, const char *host, u_short port, const char *domain,
-    struct in_addr *client_address, u_short client_port)
+    struct sockaddr *client_address)
 {
     if (domain && client_address)
-	return snprintf(buf, PCONN_KEYLEN, "%s.%d:%s.%d/%s", host, (int) port,
-	    inet_ntoa(*client_address), (int) client_port, domain);
+	return snprintf(buf, PCONN_KEYLEN, "%s.%d:%s./%s", host, (int) port,
+	    sockaddr_ntoa(client_address), domain);
     else if (domain && (!client_address))
 	return snprintf(buf, PCONN_KEYLEN, "%s.%d/%s", host, (int) port, domain);
     else if ((!domain) && client_address)
-	return snprintf(buf, PCONN_KEYLEN, "%s.%d:%s.%d", host, (int) port,
-	    inet_ntoa(*client_address), (int) client_port);
+	return snprintf(buf, PCONN_KEYLEN, "%s.%d:%s.", host, (int) port,
+	    sockaddr_ntoa(client_address));
     else
 	return snprintf(buf, PCONN_KEYLEN, "%s:%d", host, (int) port);
 }
@@ -194,7 +194,7 @@
 }
 
 void
-pconnPush(int fd, const char *host, u_short port, const char *domain, struct in_addr *client_address, u_short client_port)
+pconnPush(int fd, const char *host, u_short port, const char *domain, struct sockaddr *client_address)
 {
     struct _pconn *p;
     int *old;
@@ -209,7 +209,7 @@
 	return;
     }
     assert(table != NULL);
-    pconnKey(key, host, port, domain, client_address, client_port);
+    pconnKey(key, host, port, domain, client_address);
     p = (struct _pconn *) hash_lookup(table, key);
     if (p == NULL)
 	p = pconnNew(key);
@@ -233,13 +233,13 @@
 }
 
 int
-pconnPop(const char *host, u_short port, const char *domain, struct in_addr *client_address, u_short client_port)
+pconnPop(const char *host, u_short port, const char *domain, struct sockaddr *client_address)
 {
     struct _pconn *p;
     hash_link *hptr;
     int fd = -1;
     assert(table != NULL);
-    hptr = pconnLookup(host, port, domain, client_address, client_port);
+    hptr = pconnLookup(host, port, domain, client_address);
     if (hptr != NULL) {
 	p = (struct _pconn *) hptr;
 	assert(p->nfds > 0);
@@ -252,11 +252,11 @@
 }
 
 hash_link *
-pconnLookup(const char *peer, u_short port, const char *domain, struct in_addr * client_address, u_short client_port)
+pconnLookup(const char *peer, u_short port, const char *domain, struct sockaddr *client_address)
 {
     LOCAL_ARRAY(char, key, PCONN_KEYLEN);
     assert(table != NULL);
-    pconnKey(key, peer, port, domain, client_address, client_port);
+    pconnKey(key, peer, port, domain, client_address);
     return hash_lookup(table, key);
 }
 
diff -r -u squid-2.6.STABLE13/src/peer_select.c new-STABLE13/src/peer_select.c
--- squid-2.6.STABLE13/src/peer_select.c	Sun Dec 10 14:24:52 2006
+++ new-STABLE13/src/peer_select.c	Sun May 13 00:59:37 2007
@@ -425,10 +425,20 @@
 	code = SOURCE_FASTEST;
     } else
 #endif
-    if (ps->closest_parent_miss.sin_addr.s_addr != any_addr.s_addr) {
+    if ((ps->closest_parent_miss.ss_family == AF_INET6) && 
+	!IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&ps->closest_parent_miss)->sin6_addr)) {
 	p = whichPeer(&ps->closest_parent_miss);
 	code = CLOSEST_PARENT_MISS;
-    } else if (ps->first_parent_miss.sin_addr.s_addr != any_addr.s_addr) {
+    } else if ((ps->closest_parent_miss.ss_family == AF_INET) &&
+	(((struct sockaddr_in *)&ps->closest_parent_miss)->sin_addr.s_addr != any_addr.s_addr)) {
+	p = whichPeer(&ps->closest_parent_miss);
+	code = CLOSEST_PARENT_MISS;
+    } else if ((ps->first_parent_miss.ss_family == AF_INET6) && 
+	!IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&ps->first_parent_miss)->sin6_addr)) {
+	p = whichPeer(&ps->first_parent_miss);
+	code = FIRST_PARENT_MISS;
+    } else if ((ps->first_parent_miss.ss_family == AF_INET) && 
+	(((struct sockaddr_in *)&ps->first_parent_miss)->sin_addr.s_addr != any_addr.s_addr)) {
 	p = whichPeer(&ps->first_parent_miss);
 	code = FIRST_PARENT_MISS;
     }
@@ -525,6 +535,11 @@
 {
     ps_state *psstate = data;
     StoreEntry *entry = psstate->entry;
+    if (!psstate->request) {
+	debug(44, 3) ("peerPingTimeout: null request\n");
+	peerSelectStateFree(psstate);
+	return;
+    }
     if (entry)
 	debug(44, 3) ("peerPingTimeout: '%s'\n", storeUrl(entry));
     if (!cbdataValid(psstate->callback_data)) {
@@ -567,12 +582,21 @@
     if (p->options.closest_only)
 	return;
     /* set FIRST_MISS if there is no CLOSEST parent */
-    if (ps->closest_parent_miss.sin_addr.s_addr != any_addr.s_addr)
+    if ((ps->closest_parent_miss.ss_family == AF_INET6) && 
+	!IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&ps->closest_parent_miss)->sin6_addr)) 
+	return;
+    else if ((ps->closest_parent_miss.ss_family == AF_INET) &&
+	(((struct sockaddr_in *)&ps->closest_parent_miss)->sin_addr.s_addr != any_addr.s_addr)) 
 	return;
     rtt = tvSubMsec(ps->ping.start, current_time) / p->weight;
-    if (ps->first_parent_miss.sin_addr.s_addr == any_addr.s_addr ||
-	rtt < ps->ping.w_rtt) {
-	ps->first_parent_miss = p->in_addr;
+    if ((
+    ((ps->first_parent_miss.ss_family == AF_INET6) && 
+	IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&ps->first_parent_miss)->sin6_addr)) ||
+    ((ps->first_parent_miss.ss_family == AF_INET) && 
+	(((struct sockaddr_in *)&ps->first_parent_miss)->sin_addr.s_addr != any_addr.s_addr)) 
+	)
+	|| rtt < ps->ping.w_rtt) {
+	xmemcpy(&ps->first_parent_miss, &p->in_addr, sizeof(&p->in_addr));
 	ps->ping.w_rtt = rtt;
     }
 }
@@ -655,11 +679,20 @@
     if (p->options.closest_only)
 	return;
     /* set FIRST_MISS if there is no CLOSEST parent */
-    if (ps->closest_parent_miss.sin_addr.s_addr != any_addr.s_addr)
-	return;
+    if ((ps->closest_parent_miss.ss_family == AF_INET6) &&
+        !IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&ps->closest_parent_miss)->sin6_addr))
+        return;
+    else if ((ps->closest_parent_miss.ss_family == AF_INET) &&
+        (((struct sockaddr_in *)&ps->closest_parent_miss)->sin_addr.s_addr != any_addr.s_addr))
+        return;
     rtt = tvSubMsec(ps->ping.start, current_time) / p->weight;
-    if (ps->first_parent_miss.sin_addr.s_addr == any_addr.s_addr ||
-	rtt < ps->ping.w_rtt) {
+    if ((
+    ((ps->first_parent_miss.ss_family == AF_INET6) &&
+        IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&ps->first_parent_miss)->sin6_addr)) ||
+    ((ps->first_parent_miss.ss_family == AF_INET) &&
+        (((struct sockaddr_in *)&ps->first_parent_miss)->sin_addr.s_addr != any_addr.s_addr))
+        )
+	|| rtt < ps->ping.w_rtt) {
 	ps->first_parent_miss = p->in_addr;
 	ps->ping.w_rtt = rtt;
     }
diff -r -u squid-2.6.STABLE13/src/peer_sourcehash.c new-STABLE13/src/peer_sourcehash.c
--- squid-2.6.STABLE13/src/peer_sourcehash.c	Tue May 16 13:52:26 2006
+++ new-STABLE13/src/peer_sourcehash.c	Sun May 13 00:59:37 2007
@@ -136,7 +136,7 @@
     double high_score = 0;
     char *key = NULL;
 
-    key = inet_ntoa(request->client_addr);
+    key = sockaddr_ntoa(&request->client_addr);
 
     /* calculate hash key */
     debug(39, 2) ("peerSourceHashSelectParent: Calculating hash for %s\n", key);
diff -r -u squid-2.6.STABLE13/src/protos.h new-STABLE13/src/protos.h
--- squid-2.6.STABLE13/src/protos.h	Tue Mar 27 08:14:09 2007
+++ new-STABLE13/src/protos.h	Sun May 13 00:59:37 2007
@@ -107,7 +107,7 @@
 extern void parse_time_t(time_t * var);
 extern void parse_cachedir_options(SwapDir * sd, struct cache_dir_option *options, int reconfiguring);
 extern void dump_cachedir_options(StoreEntry * e, struct cache_dir_option *options, SwapDir * sd);
-extern void parse_sockaddr_in_list_token(sockaddr_in_list **, char *);
+extern void parse_sockaddr_storage_list_token(sockaddr_storage_list **, char *);
 
 
 /*
@@ -131,11 +131,11 @@
 extern int cbdataLocked(const void *p);
 
 extern void clientdbInit(void);
-extern void clientdbUpdate(struct in_addr, log_type, protocol_t, squid_off_t);
-extern int clientdbCutoffDenied(struct in_addr);
+extern void clientdbUpdate(struct sockaddr *, log_type, protocol_t, squid_off_t);
+extern int clientdbCutoffDenied(struct sockaddr *);
 extern void clientdbDump(StoreEntry *);
 extern void clientdbFreeMemory(void);
-extern int clientdbEstablished(struct in_addr, int);
+extern int clientdbEstablished(struct sockaddr *, int);
 
 extern char *clientConstructTraceEcho(clientHttpRequest *);
 extern int checkNegativeHit(StoreEntry *);
@@ -149,18 +149,18 @@
 extern int commSetNonBlocking(int fd);
 extern int commUnsetNonBlocking(int fd);
 extern void commSetCloseOnExec(int fd);
-extern int comm_accept(int fd, struct sockaddr_in *, struct sockaddr_in *);
+extern int comm_accept(int fd, struct sockaddr *, struct sockaddr *);
 extern void comm_close(int fd);
 extern void comm_reset_close(int fd);
 #if LINGERING_CLOSE
 extern void comm_lingering_close(int fd);
 #endif
 extern void commConnectStart(int fd, const char *, u_short, CNCB *, void *);
-extern int comm_connect_addr(int sock, const struct sockaddr_in *);
+extern int comm_connect_addr(int sock, const struct sockaddr *);
 extern void comm_init(void);
 extern int comm_listen(int sock);
-extern int comm_open(int, int, struct in_addr, u_short port, int, const char *note);
-extern int comm_openex(int, int, struct in_addr, u_short, int, unsigned char TOS, const char *);
+extern int comm_open(int, int, struct sockaddr *, int, const char *note);
+extern int comm_openex(int, int, struct sockaddr *, int, unsigned char TOS, const char *);
 extern u_short comm_local_port(int fd);
 
 extern void commDeferFD(int fd);
@@ -169,7 +169,7 @@
 extern void commRemoveSlow(int fd);
 extern void comm_add_close_handler(int fd, PF *, void *);
 extern void comm_remove_close_handler(int fd, PF *, void *);
-extern int comm_udp_sendto(int, const struct sockaddr_in *, int, const void *, int);
+extern int comm_udp_sendto(int, const struct sockaddr *, int, const void *, int);
 extern void comm_write(int fd,
     const char *buf,
     int size,
@@ -247,7 +247,7 @@
 extern void idnsInit(void);
 extern void idnsShutdown(void);
 extern void idnsALookup(const char *, IDNSCB *, void *);
-extern void idnsPTRLookup(const struct in_addr, IDNSCB *, void *);
+extern void idnsPTRLookup(const struct sockaddr *, IDNSCB *, void *);
 
 extern void eventAdd(const char *name, EVH * func, void *arg, double when, int);
 extern void eventAddIsh(const char *name, EVH * func, void *arg, double delta_ish, int);
@@ -278,12 +278,12 @@
 extern void filemapFreeMemory(fileMap *);
 
 
-extern void fqdncache_nbgethostbyaddr(struct in_addr, FQDNH *, void *);
-extern const char *fqdncache_gethostbyaddr(struct in_addr, int flags);
+extern void fqdncache_nbgethostbyaddr(struct sockaddr *, FQDNH *, void *);
+extern const char *fqdncache_gethostbyaddr(struct sockaddr *, int flags);
 extern void fqdncache_init(void);
 extern void fqdnStats(StoreEntry *);
 extern void fqdncacheReleaseInvalid(const char *);
-extern const char *fqdnFromAddr(struct in_addr);
+extern const char *fqdnFromAddr(struct sockaddr *);
 extern int fqdncacheQueueDrain(void);
 extern void fqdncacheFreeMemory(void);
 extern void fqdncache_restart(void);
@@ -529,7 +529,7 @@
     const char *url,
     int reqnum,
     int pad);
-extern int icpUdpSend(int, const struct sockaddr_in *, icp_common_t *, log_type, int);
+extern int icpUdpSend(int, const struct sockaddr *, icp_common_t *, log_type, int);
 extern PF icpHandleUdp;
 extern PF icpUdpSendQueue;
 extern PF httpAccept;
@@ -573,7 +573,7 @@
 extern void wccp2ConnectionClose(void);
 #endif /* USE_WCCPv2 */
 
-extern void icpHandleIcpV3(int, struct sockaddr_in, char *, int);
+extern void icpHandleIcpV3(int, struct sockaddr *, char *, int);
 extern int icpCheckUdpHit(StoreEntry *, request_t * request);
 extern void icpConnectionsOpen(void);
 extern void icpConnectionShutdown(void);
@@ -591,8 +591,8 @@
 extern void ipcache_init(void);
 extern void stat_ipcache_get(StoreEntry *);
 extern void ipcacheCycleAddr(const char *name, ipcache_addrs *);
-extern void ipcacheMarkBadAddr(const char *name, struct in_addr);
-extern void ipcacheMarkGoodAddr(const char *name, struct in_addr);
+extern void ipcacheMarkBadAddr(const char *name, struct sockaddr *);
+extern void ipcacheMarkGoodAddr(const char *name, struct sockaddr *);
 extern void ipcacheFreeMemory(void);
 extern ipcache_addrs *ipcacheCheckNumeric(const char *name);
 extern void ipcache_restart(void);
@@ -659,7 +659,7 @@
     int *exprep,
     int *timeout);
 extern void neighborAddAcl(const char *, const char *);
-extern void neighborsUdpAck(const cache_key *, icp_common_t *, const struct sockaddr_in *);
+extern void neighborsUdpAck(const cache_key *, icp_common_t *, const struct sockaddr *);
 extern void neighborAdd(const char *, const char *, int, int, int, int, int);
 extern void neighbors_init(void);
 extern peer *peerFindByName(const char *);
@@ -680,23 +680,23 @@
 extern void peerConnectSucceded(peer *);
 extern void dump_peer_options(StoreEntry *, peer *);
 extern int peerHTTPOkay(const peer *, request_t *);
-extern peer *whichPeer(const struct sockaddr_in *from);
+extern peer *whichPeer(const struct sockaddr *from);
 #if USE_HTCP
-extern void neighborsHtcpReply(const cache_key *, htcpReplyData *, const struct sockaddr_in *);
+extern void neighborsHtcpReply(const cache_key *, htcpReplyData *, const struct sockaddr *);
 #endif
 extern void peerAddFwdServer(FwdServer ** FS, peer * p, hier_code code);
 extern int peerAllowedToUse(const peer *, request_t *);
 
 extern void netdbInit(void);
-extern void netdbHandlePingReply(const struct sockaddr_in *from, int hops, int rtt);
+extern void netdbHandlePingReply(const struct sockaddr *from, int hops, int rtt);
 extern void netdbPingSite(const char *hostname);
 extern void netdbDump(StoreEntry *);
-extern int netdbHops(struct in_addr);
+extern int netdbHops(struct sockaddr *);
 extern void netdbFreeMemory(void);
 extern int netdbHostHops(const char *host);
 extern int netdbHostRtt(const char *host);
 extern void netdbUpdatePeer(request_t *, peer * e, int rtt, int hops);
-extern void netdbDeleteAddrNetwork(struct in_addr addr);
+extern void netdbDeleteAddrNetwork(struct sockaddr *addr);
 extern void netdbBinaryExchange(StoreEntry *);
 extern EVH netdbExchangeStart;
 extern void netdbExchangeUpdatePeer(struct in_addr, peer *, double, double);
@@ -731,7 +731,7 @@
 extern void fwdLogRotate(void);
 extern void fwdStatus(FwdState *, http_status);
 #endif
-struct in_addr getOutgoingAddr(request_t * request);
+struct sockaddr_storage *getOutgoingAddr(request_t * request);
 unsigned long getOutgoingTOS(request_t * request);
 
 extern void urnStart(request_t *, StoreEntry *);
@@ -758,14 +758,14 @@
 extern void authenticateShutdown(void);
 extern void authenticateFixHeader(HttpReply *, auth_user_request_t *, request_t *, int, int);
 extern void authenticateAddTrailer(HttpReply *, auth_user_request_t *, request_t *, int);
-extern auth_acl_t authenticateTryToAuthenticateAndSetAuthUser(auth_user_request_t **, http_hdr_type, request_t *, ConnStateData *, struct in_addr);
+extern auth_acl_t authenticateTryToAuthenticateAndSetAuthUser(auth_user_request_t **, http_hdr_type, request_t *, ConnStateData *, struct sockaddr *);
 extern void authenticateAuthUserUnlock(auth_user_t * auth_user);
 extern void authenticateAuthUserLock(auth_user_t * auth_user);
 extern void authenticateAuthUserRequestUnlock(auth_user_request_t *);
 extern void authenticateAuthUserRequestLock(auth_user_request_t *);
 extern char *authenticateAuthUserRequestMessage(auth_user_request_t *);
 extern int authenticateAuthUserInuse(auth_user_t * auth_user);
-extern void authenticateAuthUserRequestRemoveIp(auth_user_request_t *, struct in_addr);
+extern void authenticateAuthUserRequestRemoveIp(auth_user_request_t *, struct sockaddr *);
 extern void authenticateAuthUserRequestClearIp(auth_user_request_t *);
 extern int authenticateAuthUserRequestIPCount(auth_user_request_t *);
 extern int authenticateDirection(auth_user_request_t *);
@@ -808,7 +808,7 @@
 
 /* ident.c */
 #if USE_IDENT
-extern void identStart(struct sockaddr_in *me, struct sockaddr_in *my_peer,
+extern void identStart(struct sockaddr *me, struct sockaddr *my_peer,
     IDCB * callback, void *cbdata);
 extern void identInit(void);
 #endif
@@ -1163,12 +1163,12 @@
 extern ErrorState *errorCon(err_type type, http_status, request_t * request);
 extern int errorPageId(const char *page_name);
 
-extern void pconnPush(int, const char *host, u_short port, const char *domain, struct in_addr *client_address, u_short client_port);
-extern int pconnPop(const char *host, u_short port, const char *domain, struct in_addr *client_address, u_short client_port);
-extern hash_link *pconnLookup(const char *peer, u_short port, const char *domain, struct in_addr *client_address, u_short client_port);
+extern void pconnPush(int, const char *host, u_short port, const char *domain, struct sockaddr *client_address);
+extern int pconnPop(const char *host, u_short port, const char *domain, struct sockaddr *client_address);
+extern hash_link *pconnLookup(const char *peer, u_short port, const char *domain, struct sockaddr *client_address);
 extern void pconnInit(void);
 
-extern int asnMatchIp(void *, struct in_addr);
+extern int asnMatchIp(void *, struct sockaddr *);
 extern void asnInit(void);
 extern void asnFreeMemory(void);
 
@@ -1198,6 +1198,8 @@
 void setUmask(mode_t mask);
 int xusleep(unsigned int usec);
 void keepCapabilities(void);
+
+extern char *sockaddr_ntoa(struct sockaddr *);
 
 #if USE_HTCP
 extern void htcpInit(void);
